;CodeVisionAVR C Compiler V1.23.8c Professional
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega16
;Program type        : Application
;Clock frequency     : 8.000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;External SRAM size  : 0
;Data Stack size     : 256
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On
;Use AVR Studio Terminal I/O   : No

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "main.vec"
	.INCLUDE "main.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0x160
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.23.8c Professional
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : MT8870
;      10 Version : 1.0
;      11 Date    : 2007/09/19
;      12 Author  : Vahid Eskandar
;      13 Company : Vahid Eskandar
;      14 Comments:  
;      15 
;      16 In yek barnameye azmayeshi ast, baraye daryafte code haye DTMF az MT8870.
;      17 Momken ast in barname be dorosti amal nakonad.
;      18 
;      19 vahid.eskandar@gmail.com
;      20 
;      21 
;      22 Chip type           : ATmega16
;      23 Program type        : Application
;      24 Clock frequency     : 8.000000 MHz
;      25 Memory model        : Small
;      26 External SRAM size  : 0
;      27 Data Stack size     : 256
;      28 *********************************************/
;      29 
;      30 #include <mega16.h>
;      31 
;      32 // Alphanumeric LCD Module functions
;      33 #asm
;      34    .equ __lcd_port=0x18
   .equ __lcd_port=0x18
;      35 #endasm

;      36 #include <lcd.h> 
;      37 #include <delay.h>   
;      38 
;      39 #define soundp PORTA.5
;      40 #define cd PORTA.4
;      41 #define ringing PINA.6
;      42 #define TLED PORTD.7
;      43 
;      44 int i;       
;      45 
;      46 // External Interrupt 0 service routine
;      47 interrupt [EXT_INT0] void ext_int0_isr(void)
;      48 {       

	.CSEG
_ext_int0_isr:
	CALL __SAVEISR
;      49 	i=0;        
	CLR  R4
	CLR  R5
;      50 	lcd_gotoxy(6,1);
	LDI  R30,LOW(6)
	CALL SUBOPT_0x0
;      51 	switch(PINA & 0x0F)
	IN   R30,0x19
	ANDI R30,LOW(0xF)
;      52 	{       
;      53 	case 10:
	CPI  R30,LOW(0xA)
	BRNE _0x11
;      54 		lcd_putchar('0');
	LDI  R30,LOW(48)
	RJMP _0x30
;      55 		break;      
;      56 	case 11:
_0x11:
	CPI  R30,LOW(0xB)
	BRNE _0x12
;      57 		lcd_putchar('*'); 
	LDI  R30,LOW(42)
	ST   -Y,R30
	CALL _lcd_putchar
;      58 		TLED=1;
	SBI  0x12,7
;      59 		break;
	RJMP _0x10
;      60 	case 12:
_0x12:
	CPI  R30,LOW(0xC)
	BRNE _0x13
;      61 		lcd_putchar('#'); 
	LDI  R30,LOW(35)
	ST   -Y,R30
	CALL _lcd_putchar
;      62 		TLED=0;
	CBI  0x12,7
;      63 		break;
	RJMP _0x10
;      64 	case 13:
_0x13:
	CPI  R30,LOW(0xD)
	BRNE _0x14
;      65 		lcd_putchar('A');
	LDI  R30,LOW(65)
	RJMP _0x30
;      66 		break; 
;      67 	case 14:
_0x14:
	CPI  R30,LOW(0xE)
	BRNE _0x15
;      68 		lcd_putchar('B');
	LDI  R30,LOW(66)
	RJMP _0x30
;      69 		break;  
;      70 	case 15:
_0x15:
	CPI  R30,LOW(0xF)
	BRNE _0x16
;      71 		lcd_putchar('C');
	LDI  R30,LOW(67)
	RJMP _0x30
;      72 		break; 
;      73 	case 0:
_0x16:
	CPI  R30,0
	BRNE _0x18
;      74 		lcd_putchar('D');
	LDI  R30,LOW(68)
	RJMP _0x30
;      75 		break;
;      76 	default:
_0x18:
;      77 		lcd_putchar('0' + (PINA & 0x0F));    
	IN   R30,0x19
	ANDI R30,LOW(0xF)
	SUBI R30,-LOW(48)
_0x30:
	ST   -Y,R30
	CALL _lcd_putchar
;      78 	}     
_0x10:
;      79 }  
	CALL __LOADISR
	RETI
;      80 
;      81 void beep()
;      82 {
_beep:
;      83 	int n;
;      84 	
;      85 	while(n<7000)
	ST   -Y,R17
	ST   -Y,R16
;	n -> R16,R17
_0x1A:
	__CPWRN 16,17,7000
	BRGE _0x1C
;      86 	{           
;      87 		soundp = !soundp;
	CLT
	SBIS 0x1B,5
	SET
	IN   R30,0x1B
	BLD  R30,5
	OUT  0x1B,R30
;      88 		delay_us(400);
	__DELAY_USW 800
;      89 		n++;     
	__ADDWRN 16,17,1
;      90 	}
	RJMP _0x1A
_0x1C:
;      91 }         
	LD   R16,Y+
	LD   R17,Y+
	RET
;      92 
;      93 void main(void)
;      94 {
_main:
;      95 // Declare your local variables here
;      96 
;      97 // Input/Output Ports initialization
;      98 // Port A initialization
;      99 // Func0=In Func1=In Func2=In Func3=In Func4=Out Func5=Out Func6=In Func7=In 
;     100 // State0=T State1=T State2=T State3=T State4=0 State5=0 State6=T State7=T 
;     101 PORTA=0x00;
	CLR  R30
	OUT  0x1B,R30
;     102 DDRA=0x30;
	LDI  R30,LOW(48)
	OUT  0x1A,R30
;     103 
;     104 // Port B initialization
;     105 // Func0=In Func1=In Func2=In Func3=Out Func4=In Func5=In Func6=In Func7=In 
;     106 // State0=T State1=T State2=T State3=1 State4=T State5=T State6=T State7=T 
;     107 PORTB=0x08;
	LDI  R30,LOW(8)
	OUT  0x18,R30
;     108 DDRB=0x08;
	OUT  0x17,R30
;     109 
;     110 // Port C initialization
;     111 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     112 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     113 PORTC=0x00;
	CLR  R30
	OUT  0x15,R30
;     114 DDRC=0x00;
	OUT  0x14,R30
;     115 
;     116 // Port D initialization
;     117 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=Out
;     118 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=0
;     119 PORTD=0x00;
	OUT  0x12,R30
;     120 DDRD=0x80;
	LDI  R30,LOW(128)
	OUT  0x11,R30
;     121 
;     122 // Timer/Counter 0 initialization
;     123 // Clock source: System Clock
;     124 // Clock value: Timer 0 Stopped
;     125 // Mode: Normal top=FFh
;     126 // OC0 output: Disconnected
;     127 TCCR0=0x00;
	CLR  R30
	OUT  0x33,R30
;     128 TCNT0=0x00;
	OUT  0x32,R30
;     129 OCR0=0x00;
	OUT  0x3C,R30
;     130 
;     131 // Timer/Counter 1 initialization
;     132 // Clock source: System Clock
;     133 // Clock value: Timer 1 Stopped
;     134 // Mode: Normal top=FFFFh
;     135 // OC1A output: Discon.
;     136 // OC1B output: Discon.
;     137 // Noise Canceler: Off
;     138 // Input Capture on Falling Edge
;     139 TCCR1A=0x00;
	OUT  0x2F,R30
;     140 TCCR1B=0x00;
	OUT  0x2E,R30
;     141 TCNT1H=0x00;
	OUT  0x2D,R30
;     142 TCNT1L=0x00;
	OUT  0x2C,R30
;     143 OCR1AH=0x00;
	OUT  0x2B,R30
;     144 OCR1AL=0x00;
	OUT  0x2A,R30
;     145 OCR1BH=0x00;
	OUT  0x29,R30
;     146 OCR1BL=0x00;
	OUT  0x28,R30
;     147 
;     148 // Timer/Counter 2 initialization
;     149 // Clock source: System Clock
;     150 // Clock value: Timer 2 Stopped
;     151 // Mode: Normal top=FFh
;     152 // OC2 output: Disconnected
;     153 ASSR=0x00;
	OUT  0x22,R30
;     154 TCCR2=0x00;
	OUT  0x25,R30
;     155 TCNT2=0x00;
	OUT  0x24,R30
;     156 OCR2=0x00;
	OUT  0x23,R30
;     157 
;     158 // External Interrupt(s) initialization
;     159 // INT0: On
;     160 // INT0 Mode: Rising Edge
;     161 // INT1: Off
;     162 // INT2: Off
;     163 GICR|=0x40;
	IN   R30,0x3B
	ORI  R30,0x40
	OUT  0x3B,R30
;     164 MCUCR=0x03;
	LDI  R30,LOW(3)
	OUT  0x35,R30
;     165 MCUCSR=0x00;
	CLR  R30
	OUT  0x34,R30
;     166 GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
;     167 
;     168 // Timer(s)/Counter(s) Interrupt(s) initialization
;     169 TIMSK=0x00;
	CLR  R30
	OUT  0x39,R30
;     170 
;     171 // Analog Comparator initialization
;     172 // Analog Comparator: Off
;     173 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     174 // Analog Comparator Output: Off
;     175 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     176 SFIOR=0x00;
	CLR  R30
	OUT  0x30,R30
;     177 
;     178 // LCD module initialization
;     179 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
;     180 
;     181 // Global enable interrupts
;     182 #asm("sei")
	sei
;     183 
;     184 lcd_putsf("MT8870 Project");
	__POINTW1FN _29,0
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
;     185 delay_ms(1000);
	CALL SUBOPT_0x1
;     186 lcd_clear();
	CALL _lcd_clear
;     187 lcd_putsf("Ready");
	__POINTW1FN _29,15
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
;     188 
;     189 while (1)
_0x1E:
;     190 {
;     191 	if(ringing)
	SBIS 0x19,6
	RJMP _0x21
;     192 	{        
;     193 		lcd_clear();
	CALL _lcd_clear
;     194 		lcd_putsf("Ringing...");
	__POINTW1FN _29,21
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
;     195 		delay_ms(4000);   
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     196 		i=0;
	CLR  R4
	CLR  R5
;     197 		cd=1;  
	SBI  0x1B,4
;     198 		beep();
	CALL _beep
;     199 	}
;     200 	if(cd==1)
_0x21:
	SBIS 0x1B,4
	RJMP _0x22
;     201 	{
;     202 		lcd_clear();
	CALL _lcd_clear
;     203 		lcd_putsf("Connected");  
	__POINTW1FN _29,32
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
;     204 		lcd_gotoxy(0,1);
	CLR  R30
	CALL SUBOPT_0x0
;     205 		lcd_putsf("DTMF: ");
	__POINTW1FN _29,42
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
;     206 		while(i<10)
_0x23:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CP   R4,R30
	CPC  R5,R31
	BRGE _0x25
;     207 		{
;     208 			i++;
	__GETW1R 4,5
	ADIW R30,1
	__PUTW1R 4,5
;     209 			delay_ms(1000);
	CALL SUBOPT_0x1
;     210 		}      
	RJMP _0x23
_0x25:
;     211 		cd=0;          
	CBI  0x1B,4
;     212 		lcd_clear();
	CALL _lcd_clear
;     213 		lcd_putsf("Ready");
	__POINTW1FN _29,49
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
;     214 	}	
;     215 };
_0x22:
	RJMP _0x1E
;     216 }
_0x26:
	RJMP _0x26
;     217 
;     218 // END OF PROGRAM

	.DSEG
__base_y_G2:
	.BYTE 0x4
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    sbic  __lcd_pin,__lcd_busy_flag
    rjmp  __lcd_busy
    cbi   __lcd_port,__lcd_enable ;EN=0
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_gotoxy:
	CALL __lcd_ready
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-__base_y_G2)
	SBCI R31,HIGH(-__base_y_G2)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	CALL __lcd_write_data
	LDD  R6,Y+1
	LDD  R7,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	CALL __lcd_ready
	LDI  R30,LOW(12)
	CALL SUBOPT_0x2
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
	CLR  R30
	MOV  R7,R30
	MOV  R6,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R6
	CP   R8,R6
	BRSH _0x2C
	__lcd_putchar1:
	INC  R7
	CLR  R30
	ST   -Y,R30
	ST   -Y,R7
	CALL _lcd_gotoxy
	brts __lcd_putchar0
_0x2C:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_putsf:
    ld   r30,y
    ldd  r31,y+1
__lcd_putsf0:
	lpm
    tst  r0
    breq __lcd_putsf1
    adiw r30,1
    st   -y,r0
    rcall _lcd_putchar
    rjmp __lcd_putsf0
__lcd_putsf1:
	ADIW R28,2
	RET
__long_delay:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R8,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G2,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G2,3
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x3
	CALL __long_delay
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x2
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x2
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL _lcd_clear
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x2:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __lcd_ready

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x3:
	CALL __long_delay
	LDI  R30,LOW(48)
	ST   -Y,R30
	JMP  __lcd_write_data

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

